part of tecfy_core_client_package;

class PropertyText extends Property {
  int maxLength = 25000;
  int minLength = 0;
  int lines = 1;

  bool isMultiLine=false;

  bool isPassword = false;

  PropertyText({dbName,nameAr,nameEn,this.isMultiLine=false,this.isPassword=false,this.lines=1,this.maxLength=25000,this.minLength=0}):super(dbName:dbName,nameAr:nameAr,nameEn:nameEn){
    super.propertyType = PropertyTypes.Text;
  }

  PropertyText.fromMap(Map row ) : super.fromMap(row){

    maxLength = row['maxLength'];
    minLength = row['minLength'];
    lines = row['lines'];
    isMultiLine = row['isMultiLine'];
    isPassword = row['isPassword'];
  }
  @override
  OperationResult isValid(data) {    
    if (!super.isValid(data).success) return super.isValid(data);
    
    return OperationResult(success: true);
  }

  Widget getDisplayWidget(Map data){
    return Text(data[dbName]?.toString() ?? '');
  }


Future<bool> getDefaultValue(Map<String,dynamic> data)async{
   if(data[dbName] != null && data[dbName].toString().isNotEmpty) return false;
   if(defaultString.isNotEmpty) {
     data[dbName] = defaultString;
     return true;
   }
   return false;
  }
}
