part of tecfy_core_client_package;

class ValuesService {
  static dynamic getValue(Property property,Map<String, dynamic> data, Entity entity) {
    var valueString = data[property.dbName];
    //print('Value ================= $valueString   ${property.dbName}');
    return valueString;
    if (valueString == null) return null;
    
    ValueType type;
    if(property.propertyType == PropertyTypes.Dropdown)
    type =  ValueType.Int;

    if (entity.properties.any((p) => p.dbName == valueString.split('.').first)) {

      if (!valueString.contains(".")) {
        if (isStringHasValidValue(data[valueString]?.toString(), type))
          getValueFromDynamic(data[valueString], type);
      } else {
        var props = valueString.split('.');
        var prop = entity.properties.where((p)=>p.dbName == props.first).first;
        
        if (data[props.first] == null) {
          if (data[props.first + 'Id'] != null) {
            // get entity by Id and set to data[props.first]
            
          }
        }

        //if (data[props.first] is Map)
         // return getValue(valueString.substring(1), type,data[props.first],null ); // pass the entity
        //else
          return getValueFromDynamic(data[props.first], type);
      }
    }
    if (isStringHasValidValue(valueString, type))
      return getValueFromString(valueString, type);
    return null;
  }

  static dynamic getValueFromString(String value, ValueType type) {
    switch (type) {
      case ValueType.Bool:
        return (value.toLowerCase() == "true" || value == "1");
      case ValueType.String:
        return value;
      case ValueType.Int:
        return int.tryParse(value);
        break;
      case ValueType.IntArray:
        var lst = value.split(',').map((e) => int.tryParse(e)).toList();
        lst.remove(null);
        return lst;
        break;
      case ValueType.StringArray:
        var lst = value.split(',').toList();
        lst.remove(null);
        return lst;
        break;
      case ValueType.Date:
        DateTime.parse(value);
        break;
      default:
        return value;
    }
  }

  static bool isStringHasValidValue(String value, ValueType type) {
    if (value == null || value.length == 0) return false;
    switch (type) {
      case ValueType.Bool:
        if (["0", "1", "false", "true"].contains(value.toLowerCase()))
          return true;
        break;
      case ValueType.String:
        return true;
        break;
      case ValueType.Int:
        return int.tryParse(value) != null;
        break;
      case ValueType.Date:
        if (value.contains('-') || value.contains('\\')) return true;
        break;
      case ValueType.IntArray:
        if (value is List) return true;
        break;
      case ValueType.StringArray:
        if (value is List) return true;
        break;
      default:
    }
    return false;
  }

  static dynamic getValueFromDynamic(dynamic value, ValueType type) {
    if (value is String) return getValueFromString(value, type);

    switch (type) {
      case ValueType.Bool:
        if (value is int) return value == 1;
        if (value as bool) return value;
        return false;
        break;
      case ValueType.String:
        if (value is int) return value.toString();
        return value.toString();
        break;
      case ValueType.Int:
        if (value is int) return value;
        break;
      case ValueType.IntArray:
        if (value is List) return value;
        break;
      case ValueType.StringArray:
        if (value is List) return value;
        break;
      case ValueType.Date:
        if (value is DateTime) return value;
        break;
      default:
    }
    return null;
  }
}

enum ValueType { String, Int, Bool, Date, IntArray,StringArray }
